digiKam Developer Documentation: Digikam::ImportThumbnailDelegate Class Reference

| digiKam Developer Documentation Professional Photo Management with the Power of Open Source

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Digikam::ImportThumbnailDelegate Class Reference
Inheritance diagram for Digikam::ImportThumbnailDelegate:

## Public Member Functions
| ImportThumbnailDelegate (ImportCategorizedView *const parent)
bool | acceptsActivation (const QPoint &pos, const QRect &visualRect, const QModelIndex &index, QRect *activationRect) const override
int | maximumSize () const
| Returns the minimum or maximum viewport size in the limiting dimension, width or height, depending on current flow.
int | minimumSize () const
void | setDefaultViewOptions (const QStyleOptionViewItem &option) override
| Style option with standard values to use for cached rendering.
void | setFlow (QListView::Flow flow)
Public Member Functions inherited from Digikam::ImportDelegate
| ImportDelegate (QWidget *const parent)
bool | acceptsToolTip (const QPoint &pos, const QRect &visualRect, const QModelIndex &index, QRect *tooltipRect=nullptr) const override
| These methods take four parameters: The position on viewport, the rect on viewport, the index, and optionally a parameter into which, if the return value is true, a rectangle can be written for which the return value will be true as well.
QRect | actualPixmapRect (const QModelIndex &index) const
int | calculatethumbSizeToFit (int ws)
ImportCategoryDrawer * | categoryDrawer () const
QRect | coordinatesIndicatorRect () const
QRect | downloadIndicatorRect () const
QRect | groupIndicatorRect () const
QRect | imageInformationRect () const override
| Returns the area where the image information is drawn, or null if empty / not supported.
QRect | lockIndicatorRect () const
void | paint (QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const override
QPixmap | pixmapForDrag (const QStyleOptionViewItem &option, const QList< QModelIndex > &indexes) const override
QRect | pixmapRect () const override
| Returns the area where the pixmap is drawn, or null if not supported.
void | setSpacing (int spacing) override
void | setView (ImportCategorizedView *view)
QRect | tagsRect () const
Public Member Functions inherited from Digikam::ItemViewImportDelegate
| ItemViewImportDelegate (QWidget *const parent)
bool | acceptsActivation (const QPoint &pos, const QRect &visualRect, const QModelIndex &index, QRect *activationRect=nullptr) const override
bool | acceptsToolTip (const QPoint &pos, const QRect &visualRect, const QModelIndex &index, QRect *tooltipRect=nullptr) const override
| These methods take four parameters: The position on viewport, the rect on viewport, the index, and optionally a parameter into which, if the return value is true, a rectangle can be written for which the return value will be true as well.
double | displayRatio () const
QSize | gridSize () const override
| Returns the gridsize to be set by the view.
void | mouseMoved (QMouseEvent *e, const QRect &visualRect, const QModelIndex &index) override
virtual QRect | ratingRect () const
| Returns the rectangle where the rating is drawn, or a null rectangle if not supported.
QRect | rect () const
void | setDefaultViewOptions (const QStyleOptionViewItem &option) override
| Style option with standard values to use for cached rendering.
void | setRatingEdited (const QModelIndex &index)
| Can be used to temporarily disable drawing of the rating.
void | setSpacing (int spacing) override
void | setThumbnailSize (const ThumbnailSize &thumbSize) override
| reimplemented from DItemDelegate
QSize | sizeHint (const QStyleOptionViewItem &option, const QModelIndex &index) const override
int | spacing () const
ThumbnailSize | thumbnailSize () const
Public Member Functions inherited from Digikam::DItemDelegate
| DItemDelegate (QObject *const parent=nullptr)
Public Member Functions inherited from Digikam::ItemDelegateOverlayContainer
| ItemDelegateOverlayContainer ()=default
| This is a sample implementation for delegate management methods, to be inherited by a delegate.
void | installOverlay (ItemDelegateOverlay *overlay)
void | mouseMoved (QMouseEvent *e, const QRect &visualRect, const QModelIndex &index)
QList< ItemDelegateOverlay * > | overlays () const
void | removeAllOverlays ()
void | removeOverlay (ItemDelegateOverlay *overlay)
void | setAllOverlaysActive (bool active)
void | setViewOnAllOverlays (QAbstractItemView *view)

## Protected Member Functions
int | thumbnailPixmapSize (bool withHighlight, int size)
void | updateContentWidth () override
| Reimplement this to set contentWidth.
void | updateRects () override
| In a subclass, you need to implement this method to set up the rects for drawing.
Protected Member Functions inherited from Digikam::ImportDelegate
| ImportDelegate (ImportDelegate::ImportDelegatePrivate &dd, QWidget *const parent)
void | clearCaches () override
virtual void | clearModelDataCaches ()
| Reimplement to clear caches based on model indexes (hash on row number etc.) Change signals are listened to this is called whenever such properties become invalid.
void | invalidatePaintingCache () override
| reimplement these in subclasses
bool | onActualPixmapRect (const QPoint &pos, const QRect &visualRect, const QModelIndex &index, QRect *actualRect) const
void | setModel (QAbstractItemModel *model)
virtual QPixmap | thumbnailPixmap (const QModelIndex &index) const
void | updateActualPixmapRect (const QModelIndex &index, const QRect &rect)
void | updateSizeRectsAndPixmaps () override
Protected Member Functions inherited from Digikam::ItemViewImportDelegate
| ItemViewImportDelegate (ItemViewImportDelegatePrivate &dd, QWidget *const parent)
QAbstractItemDelegate * | asDelegate () override
void | drawColorLabelLine (QPainter *p, const QRect &pixRect, int colorId) const
void | drawCreationDate (QPainter *p, const QRect &dateRect, const QDateTime &date) const
void | drawDownloadIndicator (QPainter *p, const QRect &r, int itemType) const
void | drawFileSize (QPainter *p, const QRect &r, qlonglong bytes) const
void | drawFocusRect (QPainter *p, const QStyleOptionViewItem &option, bool isSelected) const
void | drawGeolocationIndicator (QPainter *p, const QRect &r) const
void | drawGroupIndicator (QPainter *p, const QRect &r, int numberOfGroupedImages, bool open) const
void | drawImageFormat (QPainter *p, const QRect &dimsRect, const QString &mime) const
void | drawImageSize (QPainter *p, const QRect &dimsRect, const QSize &dims) const
void | drawLockIndicator (QPainter *p, const QRect &r, int lockStatus) const
void | drawMouseOverRect (QPainter *p, const QStyleOptionViewItem &option) const
void | drawName (QPainter *p, const QRect &nameRect, const QString &name) const
void | drawPickLabelIcon (QPainter *p, const QRect &r, int pickLabel) const
void | drawRating (QPainter *p, const QModelIndex &index, const QRect &ratingRect, int rating, bool isSelected) const
void | drawTags (QPainter *p, const QRect &r, const QString &tagsString, bool isSelected) const
QRect | drawThumbnail (QPainter *p, const QRect &thumbRect, const QPixmap &background, const QPixmap &thumbnail) const
| Use the tool methods for painting in subclasses.
void | prepareBackground ()
void | prepareFonts ()
void | prepareMetrics (int maxWidth)
void | prepareRatingPixmaps (bool composeOverBackground=true)
QPixmap | ratingPixmap (int rating, bool selected) const
| Returns the relevant pixmap from the cached rating pixmaps.
Protected Member Functions inherited from Digikam::DItemDelegate
QString | squeezedTextCached (QPainter *const p, int width, const QString &text) const
QPixmap | thumbnailBorderPixmap (const QSize &pixSize, bool isGrouped=false) const
Protected Member Functions inherited from Digikam::ItemDelegateOverlayContainer
virtual void | drawOverlays (QPainter *p, const QStyleOptionViewItem &option, const QModelIndex &index) const
virtual void | overlayDestroyed (QObject *o)
| Declare as slot in the derived class calling this method.

## Additional Inherited Members
Signals inherited from Digikam::ItemViewImportDelegate
void | hideNotification ()
void | requestNotification (const QModelIndex &index, const QString &message)
Signals inherited from Digikam::DItemDelegate
void | gridSizeChanged (const QSize &newSize)
void | visualChange ()
Static Public Member Functions inherited from Digikam::ImportDelegate
static QPixmap | retrieveThumbnailPixmap (const QModelIndex &index, int thumbnailSize)
| Retrieve the thumbnail pixmap in given size for the ImportItemModel::ThumbnailRole for the given index from the given index, which must adhere to ImportThumbnailModel semantics.
Static Public Member Functions inherited from Digikam::DItemDelegate
static QPixmap | makeDragPixmap (const QStyleOptionViewItem &option, const QList< QModelIndex > &indexes, double displayRatio, const QPixmap &suggestedPixmap=QPixmap())
static QString | squeezedText (const QFontMetrics &fm, int width, const QString &text)
Protected Slots inherited from Digikam::ImportDelegate
void | modelChanged ()
void | modelContentsChanged ()
Protected Slots inherited from Digikam::ItemViewImportDelegate
void | overlayDestroyed (QObject *o) override
void | slotSetupChanged ()
void | slotThemeChanged ()
Protected Attributes inherited from Digikam::ItemViewImportDelegate
ItemViewImportDelegatePrivate *const | d_ptr = nullptr
Protected Attributes inherited from Digikam::ItemDelegateOverlayContainer
QList< ItemDelegateOverlay * > | m_overlays

## Member Function Documentation

## ◆ acceptsActivation()

bool Digikam::ImportThumbnailDelegate::acceptsActivation | ( | const QPoint & | pos,
|  | const QRect & | visualRect,
|  | const QModelIndex & | index,
|  | QRect * | activationRect
| ) |  | const
| overridevirtual

Reimplemented from Digikam::ImportDelegate.

## ◆ setDefaultViewOptions()

void Digikam::ImportThumbnailDelegate::setDefaultViewOptions | ( | const QStyleOptionViewItem & | option | ) |
| overridevirtual

option.rect shall be the viewport rectangle. Call on resize, font change.

Reimplemented from Digikam::ImportDelegate.

## ◆ updateContentWidth()

void Digikam::ImportThumbnailDelegate::updateContentWidth | ( |  | ) |
| overrideprotectedvirtual

This is the maximum width of all content rectangles, typically excluding margins on both sides.

Reimplemented from Digikam::ImportDelegate.

## ◆ updateRects()

void Digikam::ImportThumbnailDelegate::updateRects | ( |  | ) |
| overrideprotectedvirtual

The paint() method operates depending on these rects.

Implements Digikam::ImportDelegate.